/*
 * C
 *
 * Copyright 2013 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "microej.h"
#include "native_monitor.h"
// RTX
#include <RTL.h>

#include <stdio.h>

static U64 example_task_stack[512];
__task void example_task (void);

static int32_t monitor_id;

void Java_com_is2t_examples_JavaCSyncExample_startCTask(int32_t id) {
	monitor_id = id;
	os_tsk_create_user(example_task, 10, &example_task_stack, sizeof(example_task_stack));
}

__task void example_task (void){
	printf("C TASK: about to get monitor\n");
	native_monitor_enter(monitor_id);
	printf("C TASK: got monitor\n");
	os_dly_wait(400);
	printf("C TASK: wait over, exiting monitor\n");
	native_monitor_exit(monitor_id);
	printf("C TASK: done\n");
	os_tsk_delete_self();
}
