/*
 * C
 *
 * Copyright 2013 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "microej.h"

/*
 * Initializes a new native monitor and returns its ID.
 * A native monitor is a mutual exclusion monitor that can be used
 * to synchronise a Java thread with one or more C tasks.
 */
int32_t new_native_monitor(void);

/*
 * Enters the monitor. Blocks until the monitor can be entered.
 * Once the monitor has been entered no other C task or Java thread
 * can enter it until it is released. May be called more than once
 * by the owning task or thread - a count is keep of the number
 * of calls - see native_monitor_exit.
 */
void native_monitor_enter(int32_t monitorID);

/*
 * Exits the monitor. If the number of times this function has
 * been called equals the number of times that native_monitor_enter
 * has been called then the monitor becomes available, and if a C
 * task or Java thread is waiting it is allowed to enter the
 * monitor.
 */
void native_monitor_exit(int32_t monitorID);
