/**
 * Java
 * Copyright 2013 IS2T. All rights reserved
 * For demonstration purpose only
 * IS2T PROPRIETARY / Use is subject to license terms.
 */
package com.is2t.examples;

public class JavaCSyncExample {

	public static void main(String[] args) {
		NativeMonitor nativeMonitor = new NativeMonitor();
		System.out.println("JAVA: About to enter monitor");
		nativeMonitor.enter();
		System.out.println("JAVA: Entered monitor, starting C task");
		startCTask(nativeMonitor.getId());
		System.out.println("JAVA: Sleeping...");
		sleep(4000);
		nativeMonitor.exit();
		System.out.println("JAVA: Exited monitor, C task can proceed");
		sleep(100); //ensure the C task has an opportunity to execute and enter the monitor
		System.out.println("JAVA: About to enter monitor again");
		nativeMonitor.enter();		
		System.out.println("JAVA: Done");
	}

	private static void sleep(int sleepTime) {
		try {
			Thread.sleep(sleepTime);
		} catch (InterruptedException e) {}
	}

	native private static int startCTask(int id);
}
